<?php

if (!defined("WHMCS"))
    die("This file cannot be accessed directly");

$reportdata['title'] = "Annual Invoice Report for " . $currentyear;
$reportdata['description'] = "This report shows the total INVOICED (Paid and Unpaid) broken down by month";
$reportdata['yearspagination'] = true;

$reportdata["currencyselections"] = true;
$currency = (int)$currencyid;

$reportdata['tableheadings'] = array(
    "Month",
    "Amount Invoiced",
    "VAT"
);

$reportvalues = array();

$query = "SELECT tblinvoiceitems.invoiceid, date_format(tblinvoices.date,'%m'), date_format(tblinvoices.date,'%Y'), SUM(tblinvoiceitems.amount), SUM(tblinvoiceitems.taxed) FROM tblinvoiceitems left join tblinvoices on tblinvoiceitems.invoiceid=tblinvoices.id WHERE tblinvoices.date >= '" . ($currentyear-2) . "-01-01' AND tblinvoices.status != 'Cancelled' AND tblinvoices.status != 'Refunded' AND tblinvoiceitems.type != 'Invoice' GROUP BY date_format(tblinvoices.date,'%M %Y') ORDER BY tblinvoices.date ASC";

$querytax = "SELECT date_format(date,'%m'), date_format(date,'%Y'), SUM(tax) FROM tblinvoices WHERE date >= '" . ($currentyear-2) . "-01-01' AND status != 'Cancelled' AND status != 'Refunded' GROUP BY date_format(date,'%M %Y') ORDER BY date ASC";


$result = full_query($query);
while ($data = mysql_fetch_array($result)) {

    $month = (int)$data[1];
    $year = (int)$data[2];
    $amountin = $data[3];

    $reportvalues[$year][$month] = array('amount'=>$amountin, 'tax'=>0);

}

$resulttax = full_query($querytax);
while ($data = mysql_fetch_array($resulttax)) {

    $month = (int)$data[0];
    $year = (int)$data[1];
    $vatin = $data[2];

    $reportvalues[$year][$month]['tax'] += $vatin;

}


foreach ($months as $k => $monthName) {

    if ($monthName) {

        $amountin = $reportvalues[$currentyear][$k]['amount'];
        $vatin = $reportvalues[$currentyear][$k]['tax'];

        $reportdata['tablevalues'][] = array(
            $monthName . ' ' . $currentyear,
            formatCurrency($amountin),
            formatCurrency($vatin),
        );

        $overallbalance += $amountin;
        $overallvat += $vatin;
    }

}

$thisday = date("z");
$thisyear = date("Y");

$reportdata['footertext'] = '<p align="center"><strong>Total Invoiced : ' . formatCurrency($overallbalance) . ' ( + VAT : ' . formatCurrency($overallvat) . ' )</strong></p>';
if ($currentyear == $thisyear) $reportdata['footertext'] .= '<p align="center"><strong>Estimated Annual : ' . formatCurrency($overallbalance/$thisday*365) . '</strong></p>';
$chartdata['cols'][] = array('label'=>'Days Range','type'=>'string');
$chartdata['cols'][] = array('label'=>$currentyear-2,'type'=>'number');
$chartdata['cols'][] = array('label'=>$currentyear-1,'type'=>'number');
$chartdata['cols'][] = array('label'=>$currentyear,'type'=>'number');

for ($i = 1; $i <= 12; $i++) {
    $chartdata['rows'][] = array(
        'c'=>array(
            array(
                'v'=>$months[$i],
            ),
            array(
                'v'=>$reportvalues[$currentyear-2][$i]['amount'],
                'f'=>formatCurrency($reportvalues[$currentyear-2][$i]['amount'])->toFull(),
            ),
            array(
                'v'=>$reportvalues[$currentyear-1][$i]['amount'],
                'f'=>formatCurrency($reportvalues[$currentyear-1][$i]['amount'])->toFull(),
            ),
            array(
                'v'=>$reportvalues[$currentyear][$i]['amount'],
                'f'=>formatCurrency($reportvalues[$currentyear][$i]['amount'])->toFull(),
            ),
        ),
    );
}

$args = array();
$args['colors'] = '#3070CF,#F9D88C,#cb4c30';
$args['chartarea'] = '80,20,90%,350';

$reportdata['headertext'] = $chart->drawChart('Column',$chartdata,$args,'400px');
